#ifdef WIN32
#include <windows.h>
#endif

#include <iostream.h>
#include <assert.h>

#include "GroupNode.h"
#include "Rect.h"

// ============================================================= GroupNode::GroupNode(void) : Rect()
//
GroupNode::GroupNode(void) : Rect()
{
	next=child=NULL;
}

// ===================================================================== GroupNode::~GroupNode(void)
//
GroupNode::~GroupNode(void)
{
	// TODO: zastanowic sie nad procesem kasowania!
	#ifdef DEBUG
		cerr<<"<"<<this<<"> GroupNode::~GroupNode(void) child("<<child<<") next("<<next<<")"<<endl;
	#endif
	delete child;
	delete next;
}

// ============================================================= GroupNode* GroupNode::Ungroup(void)
//
GroupNode* GroupNode::Ungroup(void)
{
	// TODO: wszystke z poziomu "child" powinny dostac "select" ?
	// TODO: aktualizacja rozmiaru/pozycji
	Add(child); // przenosimy "child" na koniec po "next"
	child=NULL; 

	return this; // by mozna bylo zastosowac Deatach/delete
}

// ========================================================= GroupNode* GroupNode::Add(GroupNode* g)
//
GroupNode* GroupNode::Add(GroupNode* g)
{
	GroupNode* last = GetLast();          // szukamy ostatniego elementu
	                                      // dodajemy "g" na koniec
	return g!=NULL ? last->next=g : last; // i zwracamy statni element na liscie
}

// ==================================================== GroupNode* GroupNode::AddChild(GroupNode* g)
//
GroupNode* GroupNode::AddChild(GroupNode* g)
{
	// TODO: Aktualizacja rozmiaru/pozycji
	GroupNode* where;

	if(child!=NULL)
		where = child->Add(g);
	else
		where = child = g;
		
	return where;
}

// ============================================================= GroupNode* GroupNode::GetNext(void)
//
GroupNode* GroupNode::GetNext(void)
{
	return next;
}

// ============================================================= GroupNode* GroupNode::GetLast(void)
//
GroupNode* GroupNode::GetLast(void)
{
	GroupNode* last = this;

	while(last->next!=NULL)
		last = last->next;
		
	return last;
}

// ============================================================ GroupNode* GroupNode::GetChild(void)
//
GroupNode* GroupNode::GetChild(void)
{
	return child;
}

// ========================================================== GroupNode* GroupNode::DeleteNext(void)
//
GroupNode* GroupNode::DeleteNext(void)
{
	if(next!=NULL)
	{
		GroupNode* tmp = next->next;
		next->next=NULL; // teraz destruktor nie usunie tych za "next"
		delete next;
		next=tmp;
	}
	return next;
}

// ========================================================= GroupNode* GroupNode::DeleteChild(void)
//
GroupNode* GroupNode::DeleteChild(void)
{
	// TODO: aktualizacja rozmiaru/pozycji
	if(child!=NULL)
	{
		GroupNode* tmp = child->next;
		child->next = NULL; // teraz destruktor nie usunie "braci" child
		delete child;
		child = tmp;
	}
	
	return child;
}

// ============================================================= GroupNode* GroupNode::Deatach(void)
//
GroupNode* GroupNode::DeatachNext(void)
{
	// TODO: aktualizacja rozmiaru/pozycji
	GroupNode* tmp = next;

	if(next!=NULL)
	{
		next = next->next;
		tmp->next = NULL; // nie chcemy calego kawalka listy, tylko ten element i jego "child"
	}

	return tmp;
}
