#ifndef _Layer_h_
#define _Layer_h_

#include <iostream.h>
#include <GL/gl.h>
#include "GroupNode.h"

enum LAYER_ID
{
	LR_NULL   = 0,

	LR_NWELL   , LR_DIFFN   , LR_DIFFP   , LR_POLY    ,
	LR_METAL1  , LR_METAL2  , LR_METAL3  , LR_METAL4  , LR_METAL5  , LR_METAL6  ,
	LR_CONTACT , LR_OPTIONS , LR_LOCAL   ,

	LR_COUNT,
	LR_FIRST = LR_NULL,
	LR_LAST = LR_COUNT-1
};

enum LAYER_TARGET
{
	LT_NULL = 0,
	LT_ARG,
	LT_ANY,
	LT_SELECTED,
	LT_NOTSELECTED,
	LT_RECTOVER,
	LT_NOTRECTOVER,
	LT_RECTXYIN,
	LT_NOTRECTXYIN
};

enum LAYER_ACTION
{
	LA_NONE = 0,
	LA_SELECT,
	LA_DESELECT,
	LA_INVSELECT,
	LA_ADD,
	LA_DELETE,
	LA_GROW,
	LA_MOVE,
	LA_SIZE
};

int GetIdByName(const char*); // zwraca identyfikator na podstawie nazwy ("NW"->LR_NWELL)
char* GetNameByID(int); // zwraca nazwe na podstwie identyfikatora (LR_NWELL->"NW")
GLubyte* GetStippleById(int); // zwraca wzor wypelnienia na podstawie identyfikatora

class Layer : public Rect
{
	private:
		GroupNode* head;
		GroupNode* active;

		int color;
		int id;
		int enabled;
	
		GroupNode* GotoNext(int what, void* ptr = NULL);
		void Rewind(void);

	public:
		Layer(void);
		~Layer(void);

		int GetId(void) const;
		void SetId(int nid);
		
		int GetColor(void) const;
		void SetColor(int nc);

		void Enable(void);
		void Disable(void);
		void InvEnabled(void);
		int Enabled(void) const;
		
		int Action(int what, int target = LT_ANY, void* helper = NULL);
		
		virtual void Draw(int mode = 0) const;

		int Save(ostream& out) const;
};

#endif
