#include <fox/fx.h>
#include "VLSIWindow.h"

FXDEFMAP(LayerDlg) LayerDlgMap[]=
{
	FXMAPFUNCS(SEL_COMMAND, LayerDlg::ID_LR_OPTIONS, LayerDlg::ID_LR_NWELL, LayerDlg::onCmdSelectLayer),
	FXMAPFUNCS(SEL_UPDATE,  LayerDlg::ID_LR_OPTIONS, LayerDlg::ID_LR_NWELL, LayerDlg::onUpdSelectLayer),
	FXMAPFUNCS(SEL_COMMAND, LayerDlg::ID_ENABLE_OPTIONS, LayerDlg::ID_ENABLE_NWELL, LayerDlg::onCmdEnableLayer),
	FXMAPFUNCS(SEL_UPDATE,  LayerDlg::ID_ENABLE_OPTIONS, LayerDlg::ID_ENABLE_NWELL, LayerDlg::onUpdEnableLayer),
};

FXIMPLEMENT(LayerDlg,FXDialogBox,LayerDlgMap,ARRAYNUMBER(LayerDlgMap))

// ============================================================ LayerDlg::LayerDlg(FXWindow* owner): 
//
LayerDlg::LayerDlg(FXWindow* owner): 
	FXDialogBox(owner,"Layers",DECOR_TITLE|DECOR_CLOSE|DECOR_BORDER)
{
	// TODO: dopisac tooltipsy do klawiszy

	// XXX uwaga!!! tylko VLSIWindow moze byc rodzicem!!!
	VLSIWindow* w = (VLSIWindow*) owner;
	FXHorizontalFrame*  b1 = new FXHorizontalFrame(this,LAYOUT_SIDE_TOP|FRAME_SUNKEN|LAYOUT_FILL_X);
		new FXButton(b1,"\t\t",w->vdd_ico);
		new FXButton(b1,"\t\t",w->sine_ico);
		new FXButton(b1,"\t\t",w->pulse_ico);
		new FXButton(b1,"\t\t",w->square_ico);
		new FXButton(b1,"\t\t",w->out_ico);

	FXHorizontalFrame*  b2 = new FXHorizontalFrame(this,LAYOUT_SIDE_TOP|FRAME_SUNKEN|LAYOUT_FILL_X);
		new FXButton(b2,"\t\t",w->vss_ico);
		new FXButton(b2,"\t\t",w->difn_met_ico);
		new FXButton(b2,"\t\t",w->difp_met_ico);
		new FXButton(b2,"\t\t",w->pol_met_ico);
		new FXButton(b2,"\t\t",w->via_met_ico);

	#define BTN_LAY FRAME_RAISED|FRAME_THICK|JUSTIFY_LEFT|ICON_BEFORE_TEXT|LAYOUT_FIX_WIDTH
	FXMatrix* m = new FXMatrix(this,2,MATRIX_BY_COLUMNS|LAYOUT_FILL_X);
		new FXCheckButton(m,"\t\t",this,ID_ENABLE_OPTIONS); new FXButton(m,"Options",w->lay_op_ico,this,ID_LR_OPTIONS,BTN_LAY,0,0,120);
		new FXCheckButton(m,"\t\t",this,ID_ENABLE_METAL6);  new FXButton(m,"Metal 6",w->lay_m6_ico,this,ID_LR_METAL6,BTN_LAY,0,0,120);
		new FXCheckButton(m,"\t\t",this,ID_ENABLE_METAL5);  new FXButton(m,"Metal 5",w->lay_m5_ico,this,ID_LR_METAL5,BTN_LAY,0,0,120);
		new FXCheckButton(m,"\t\t",this,ID_ENABLE_METAL4);  new FXButton(m,"Metal 4",w->lay_m4_ico,this,ID_LR_METAL4,BTN_LAY,0,0,120);
		new FXCheckButton(m,"\t\t",this,ID_ENABLE_METAL3);  new FXButton(m,"Metal 3",w->lay_m3_ico,this,ID_LR_METAL3,BTN_LAY,0,0,120);
		new FXCheckButton(m,"\t\t",this,ID_ENABLE_METAL2);  new FXButton(m,"Metal 2",w->lay_m2_ico,this,ID_LR_METAL2,BTN_LAY,0,0,120);
		new FXCheckButton(m,"\t\t",this,ID_ENABLE_METAL1);  new FXButton(m,"Metal 1",w->lay_m1_ico,this,ID_LR_METAL1,BTN_LAY,0,0,120);
		new FXCheckButton(m,"\t\t",this,ID_ENABLE_CONTACT); new FXButton(m,"Contact",w->lay_co_ico,this,ID_LR_CONTACT,BTN_LAY,0,0,120);
		new FXCheckButton(m,"\t\t",this,ID_ENABLE_LOCAL);   new FXButton(m,"Local Inerc",NULL,this,ID_LR_LOCAL,BTN_LAY,0,0,120);
		new FXCheckButton(m,"\t\t",this,ID_ENABLE_POLY);    new FXButton(m,"Polisilicium",w->lay_po_ico,this,ID_LR_POLY,BTN_LAY,0,0,120);
		new FXCheckButton(m,"\t\t",this,ID_ENABLE_DIFFP);   new FXButton(m,"P+ Diffusion",w->lay_dp_ico,this,ID_LR_DIFFP,BTN_LAY,0,0,120);
		new FXCheckButton(m,"\t\t",this,ID_ENABLE_DIFFN);   new FXButton(m,"N+ Diffusion",w->lay_dn_ico,this,ID_LR_DIFFN,BTN_LAY,0,0,120);
		new FXCheckButton(m,"\t\t",this,ID_ENABLE_NWELL);   new FXButton(m,"N Well",w->lay_nw_ico,this,ID_LR_NWELL,BTN_LAY,0,0,120);
	#undef BTN_LAY              
}                             
                              
// ================ long LayerDlg::onCmdSelectLayer(FXObject* sender,FXSelector selector, void* ptr)
//
long LayerDlg::onCmdSelectLayer(FXObject* sender,FXSelector selector, void* ptr)
{
	VLSIWindow *w = (VLSIWindow*) getOwner();
	#ifdef DEBUG
		cerr<<"<"<<this<<"> LayerDlg::onCmdSelectLayer("<<sender<<","<<selector<<","<<ptr<<")"<<endl;
	#endif
	switch(SELID(selector))
	{
		case ID_LR_NULL:    w->active_layer = LR_NULL;    break;
		case ID_LR_OPTIONS: w->active_layer = LR_OPTIONS; break;
		case ID_LR_METAL6:  w->active_layer = LR_METAL6;  break;
		case ID_LR_METAL5:  w->active_layer = LR_METAL5;  break;
		case ID_LR_METAL4:  w->active_layer = LR_METAL4;  break;
		case ID_LR_METAL3:  w->active_layer = LR_METAL3;  break;
		case ID_LR_METAL2:  w->active_layer = LR_METAL2;  break;
		case ID_LR_METAL1:  w->active_layer = LR_METAL1;  break;
		case ID_LR_CONTACT: w->active_layer = LR_CONTACT; break;
		case ID_LR_LOCAL:   w->active_layer = LR_LOCAL;   break;
		case ID_LR_POLY:    w->active_layer = LR_POLY;    break;
		case ID_LR_DIFFP:   w->active_layer = LR_DIFFP;   break;
		case ID_LR_DIFFN:   w->active_layer = LR_DIFFN;   break;
		case ID_LR_NWELL:   w->active_layer = LR_NWELL;   break;
	}

	return 1;
}

// ================ long LayerDlg::onUpdSelectLayer(FXObject* sender,FXSelector selector, void* ptr)
//
long LayerDlg::onUpdSelectLayer(FXObject* sender,FXSelector selector, void* ptr)
{
	VLSIWindow *w = (VLSIWindow*) getOwner();
	FXuint msg; 

	switch(SELID(selector))
	{
		case ID_LR_NULL:    msg = (w->active_layer == LR_NULL)    ? ID_CHECK : ID_UNCHECK; break;
		case ID_LR_OPTIONS: msg = (w->active_layer == LR_OPTIONS) ? ID_CHECK : ID_UNCHECK; break;
		case ID_LR_METAL6:  msg = (w->active_layer == LR_METAL6)  ? ID_CHECK : ID_UNCHECK; break;
		case ID_LR_METAL5:  msg = (w->active_layer == LR_METAL5)  ? ID_CHECK : ID_UNCHECK; break;
		case ID_LR_METAL4:  msg = (w->active_layer == LR_METAL4)  ? ID_CHECK : ID_UNCHECK; break;
		case ID_LR_METAL3:  msg = (w->active_layer == LR_METAL3)  ? ID_CHECK : ID_UNCHECK; break;
		case ID_LR_METAL2:  msg = (w->active_layer == LR_METAL2)  ? ID_CHECK : ID_UNCHECK; break;
		case ID_LR_METAL1:  msg = (w->active_layer == LR_METAL1)  ? ID_CHECK : ID_UNCHECK; break;
		case ID_LR_CONTACT: msg = (w->active_layer == LR_CONTACT) ? ID_CHECK : ID_UNCHECK; break;
		case ID_LR_LOCAL:   msg = (w->active_layer == LR_LOCAL)   ? ID_CHECK : ID_UNCHECK; break;
		case ID_LR_POLY:    msg = (w->active_layer == LR_POLY)    ? ID_CHECK : ID_UNCHECK; break;
		case ID_LR_DIFFP:   msg = (w->active_layer == LR_DIFFP)   ? ID_CHECK : ID_UNCHECK; break;
		case ID_LR_DIFFN:   msg = (w->active_layer == LR_DIFFN)   ? ID_CHECK : ID_UNCHECK; break;
		case ID_LR_NWELL:   msg = (w->active_layer == LR_NWELL)   ? ID_CHECK : ID_UNCHECK; break;
	}
	sender->handle(this,MKUINT(msg,SEL_COMMAND),ptr);

	return 1;
}

// ================ long LayerDlg::onCmdEnableLayer(FXObject* sender,FXSelector selector, void* ptr)
//
long LayerDlg::onCmdEnableLayer(FXObject* sender,FXSelector selector, void* ptr)
{
	VLSIWindow *w = (VLSIWindow*) getOwner();
	#ifdef DEBUG
		cerr<<"<"<<this<<"> LayerDlg::onCmdEnableLayer("<<sender<<","<<selector<<","<<ptr<<")"<<endl;
	#endif

	switch(SELID(selector))
	{
		case ID_ENABLE_OPTIONS: w->LAYER[LR_OPTIONS].InvEnabled(); break;
		case ID_ENABLE_METAL6:  w->LAYER[LR_METAL6].InvEnabled();  break;
		case ID_ENABLE_METAL5:  w->LAYER[LR_METAL5].InvEnabled();  break;
		case ID_ENABLE_METAL4:  w->LAYER[LR_METAL4].InvEnabled();  break;
		case ID_ENABLE_METAL3:  w->LAYER[LR_METAL3].InvEnabled();  break;
		case ID_ENABLE_METAL2:  w->LAYER[LR_METAL2].InvEnabled();  break;
		case ID_ENABLE_METAL1:  w->LAYER[LR_METAL1].InvEnabled();  break;
		case ID_ENABLE_CONTACT: w->LAYER[LR_CONTACT].InvEnabled(); break;
		case ID_ENABLE_LOCAL:   w->LAYER[LR_LOCAL].InvEnabled();   break;
		case ID_ENABLE_POLY:    w->LAYER[LR_POLY].InvEnabled();    break;
		case ID_ENABLE_DIFFP:   w->LAYER[LR_DIFFP].InvEnabled();   break;
		case ID_ENABLE_DIFFN:   w->LAYER[LR_DIFFN].InvEnabled();   break;
		case ID_ENABLE_NWELL:   w->LAYER[LR_NWELL].InvEnabled();   break;
	}
	w->handle(this,MKUINT(VLSIWindow::ID_GLCANVAS,SEL_PAINT),NULL);

	return 1;
}

// ================ long LayerDlg::onUpdEnableLayer(FXObject* sender,FXSelector selector, void* ptr)
//
long LayerDlg::onUpdEnableLayer(FXObject* sender,FXSelector selector, void* ptr)
{
	VLSIWindow *w = (VLSIWindow*) getOwner();
	FXuint msg; 

	switch(SELID(selector))
	{
		case ID_ENABLE_OPTIONS: msg = (w->LAYER[LR_OPTIONS].Enabled()) ? ID_CHECK : ID_UNCHECK; break;
		case ID_ENABLE_METAL6:  msg = (w->LAYER[LR_METAL6].Enabled()) ? ID_CHECK : ID_UNCHECK;  break;
		case ID_ENABLE_METAL5:  msg = (w->LAYER[LR_METAL5].Enabled()) ? ID_CHECK : ID_UNCHECK;  break;
		case ID_ENABLE_METAL4:  msg = (w->LAYER[LR_METAL4].Enabled()) ? ID_CHECK : ID_UNCHECK;  break;
		case ID_ENABLE_METAL3:  msg = (w->LAYER[LR_METAL3].Enabled()) ? ID_CHECK : ID_UNCHECK;  break;
		case ID_ENABLE_METAL2:  msg = (w->LAYER[LR_METAL2].Enabled()) ? ID_CHECK : ID_UNCHECK;  break;
		case ID_ENABLE_METAL1:  msg = (w->LAYER[LR_METAL1].Enabled()) ? ID_CHECK : ID_UNCHECK;  break;
		case ID_ENABLE_CONTACT: msg = (w->LAYER[LR_CONTACT].Enabled()) ? ID_CHECK : ID_UNCHECK; break;
		case ID_ENABLE_LOCAL:   msg = (w->LAYER[LR_LOCAL].Enabled()) ? ID_CHECK : ID_UNCHECK;   break;
		case ID_ENABLE_POLY:    msg = (w->LAYER[LR_POLY].Enabled()) ? ID_CHECK : ID_UNCHECK;    break;
		case ID_ENABLE_DIFFP:   msg = (w->LAYER[LR_DIFFP].Enabled()) ? ID_CHECK : ID_UNCHECK;   break;
		case ID_ENABLE_DIFFN:   msg = (w->LAYER[LR_DIFFN].Enabled()) ? ID_CHECK : ID_UNCHECK;   break;
		case ID_ENABLE_NWELL:   msg = (w->LAYER[LR_NWELL].Enabled()) ? ID_CHECK : ID_UNCHECK;   break;
	}
	sender->handle(this,MKUINT(msg,SEL_COMMAND),ptr);

	return 1;
}
