#ifndef _MouseRect_h
#define _MouseRect_h_
    
#include "Rect.h"

enum MOUSE_MODE
{	
	MM_NONE   = 0x000, // nic ciekawego sie nie dzieje
	MM_EDIT   = 0x100, // edycja: zaznaczanie, zmiana rozmiaru/pozycji
	MM_DRAW   = 0x200, // rysowanie: dodawanie obiektow
	MM_LOOK   = 0x300, // zmiana pozycji obserwatora

	MM_SELECT_ADD  = MM_EDIT | 0x01, // dodawanie elementow do zaznaczenia
	MM_SELECT_DEL  = MM_EDIT | 0x02, // usuwanie elementow z listy zaznaczonych
	MM_SELECT_INV  = MM_EDIT | 0x03, // zamiana zaznaczone<->niezaznaczone
	MM_DRAG        = MM_EDIT | 0x04, // noszenie 
	MM_SIZE        = MM_EDIT | 0x05, // zmienia rozmiaru 
	                
	MM_DRAWING     = MM_DRAW | 0x01, // rysowanie prostokatow

	MM_ZOOM        = MM_LOOK | 0x01, // zoom
	MM_MOVE        = MM_LOOK | 0x02, // zmiana pozycji

	MM_MAINMODE    = 0xF00,
	MM_SUBMODE     = 0x0FF
};

class MouseRect : public Rect
{
	private:
		int left;   // stan lewego klawisza myszy
		int right;  // stan prawego klawisza myszy
		int mousex, mousey; 
		int clickx, clicky;
		int mode;

	public:
		MouseRect(void);
		virtual ~MouseRect(void);

    void LeftDown(int nx, int ny);
    void LeftUp(int nx, int ny);
    void RightDown(int nx, int ny);
    void RightUp(int nx, int ny);
    void Motion(int nx, int ny);

    int SetMode(int m); 
    int GetMode(void) const;
    int GetMode(int mask) const;
		
    int MouseX(void) const;
    int MouseY(void) const;
    int ClickX(void) const;
    int ClickY(void) const;

    int Left(void) const;
    int Right(void) const;

    void Draw(int mode = 0) const;
};

#endif
